import static org.junit.Assert.*;
import org.junit.*;
import java.util.*;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

@RunWith(Parameterized.class)
public class RPNCalcTest {
	private static final String COM = "Błąd dla wyrażenia: ";
	private String expression;
	private double result;

	public RPNCalcTest(String expression, double result) {
		this.expression = expression;
		this.result = result;
	}
	
	@Parameters
	public static Collection<Object[]> data() {
		return Arrays.asList(new Object[][]{
				{"5-2",3.0},
				{"(23+5)*3",84.0},
				{"23*5+3/4",115.75},
				{"(23+8)*(5+6)",341.0},
				{"(35+25)/(23-90)",-0.8955223880597015},
				{"25/(23-90)",-0.373134328358209},
				{"3*(2+(40-3)*7)+5",788.0}
				});
	}
	
	@Test
	public void testExpressions() {
		RPNCalc calc = new RPNCalc();
		assertEquals(COM+expression,result,calc.calculate(expression),0.00001);
	}

}
